package com.kiand.bt;
 
import java.io.IOException;
import java.io.OutputStream;
import java.util.UUID;
 
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.util.Log;
 

public class BtCore 
{
	private static final String TAG = "RGB-CONTR";
	 
	private static BluetoothAdapter mBluetoothAdapter = null;
	private static BluetoothSocket btSocket = null;
	private static OutputStream outStream = null;
	
	public static final int REQUEST_DISCOVERY = 0x1;;
	public static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");

	//  hardcode your server's MAC address here <==
	public static String serverAddress = "0A:17:07:0B:25:16";
	public static String _serverAddressAfterScan = "";
	
	public static int initBluetooth()
	{
		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		
		return 0;
	}
	
	public static int createSocketBluetooth()
	{
		if (_serverAddressAfterScan != "")
		{
			serverAddress = _serverAddressAfterScan;
			Log.v(TAG, "Use server Address after Scan:" + serverAddress);
		}
		BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(serverAddress);
		try 
		{
			btSocket = device.createRfcommSocketToServiceRecord(MY_UUID);
			String remoteName = device.getName();
		}
		catch (IOException e) 
		{
			Log.e(TAG, "RESUME: Socket creation failed.", e);
			return -1;
		}
		mBluetoothAdapter.cancelDiscovery(); // rallenterebbe
		return 0;
	}	
	
	public static int connectBluetooth()
	{
		try 
		{
			btSocket.connect();
			Log.v(TAG, "RESUME: BT connection established, data transfer link open.");			
		} 
		catch (IOException e) 
		{	
			try
			{
				btSocket.close();
			}
			catch (IOException e2) 
			{
				Log.v(TAG, "RESUME: Unable to close socket during connection failure", e2);
			}
			return -1;
		}
		
		try 
		{
			outStream = btSocket.getOutputStream();
		}
		catch (IOException e) 
		{
			Log.e(TAG, "RESUME: Output stream creation failed.", e);
			return -2;
		}
		return 0;
	}
 
	
	public static void sendMessageBluetooth(String message)
	{
		if (outStream == null) 
		{
			Log.e(TAG, "stream is Null");
			return;	
		}
		byte[] msgBuffer = message.getBytes();
		try 
		{
			outStream.write(msgBuffer);
			Log.v(TAG, "btSended:" + message);
		}
		catch (IOException e) 
		{
			Log.e(TAG, "seekbarLeft: Exception during write.", e);
		}
	}
	
	public static void closeBluetooth()
	{
		if (outStream != null) 
		{
			try 
			{
				outStream.flush();
			} 
			catch (IOException e) 
			{
				Log.e(TAG, "ON PAUSE: Couldn't flush output stream.", e);
			}
		}

		try	
		{
			btSocket.close();
		}
		catch (IOException e2) 
		{
			Log.e(TAG, "ON PAUSE: Unable to close socket.", e2);
		}
	}
	
	 
}




