package com.kiand.bt;

import android.app.Activity;
import android.os.Bundle;
import java.io.IOException;
import java.io.OutputStream;
import java.util.UUID;

import org.apache.http.protocol.RequestDate;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.util.Log;
import android.widget.Toast;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.ToggleButton;
import android.os.Handler;
import android.view.View;
import android.content.Context;
import android.view.Gravity;
import android.content.Intent; 
import android.graphics.Color;

public class BtclientActivity extends Activity implements SeekBar.OnSeekBarChangeListener
{
	
	private static final String TAG = "RGB-CONTR";
	private static final boolean Debug = true;
	
	private BluetoothAdapter mBluetoothAdapter = null;
	private BluetoothSocket btSocket = null;
	private OutputStream outStream = null;
	
	

	private int _RValue = 0;
	private int _GValue = 0;
	private int _BValue = 0;
	
	// gui
	private Button _buttonLeftR;
	private Button _buttonRightR;

	private Button _buttonLeftG;
	private Button _buttonRightG;
	
	private Button _buttonLeftB;
	private Button _buttonRightB;
	
	private SeekBar  _seekBarR;
	private SeekBar  _seekBarG;
	private SeekBar  _seekBarB;
	
	private TextView _textViewR;
	private TextView _textViewG;
	private TextView _textViewB;
	
	private ToggleButton _toggleOnOff;
	
	private Button _buttonScan;
	
/*
	private Button _buttonLoad; 
	private Button _buttonSave;
	private Button _buttonDemo;
	 
*/
 	 
	// control
 	private int _stepSpeed = 	5;
	private int MaxDemoValues = 5;
	
	// create demo
	private int _listSpeedLeft[] = new int[6];
	private int _listSpeedRight[] = new int[6];
	private int _listDirLeft[] = new int[6];
	private int _listDirRight[] = new int[6];
	 
	 
 /*
	private Runnable mUpdate = new Runnable() {
		   public void run() {

		       _textInfo.setText( _i + " L:" + _listSpeedLeft[_i] +
		    		   				   " R:" + _listSpeedRight[_i] + 
		    		   				   " DL: " + _listDirLeft[_i] +
		    		   				   " DR: " + _listDirRight[_i]);
		       
		       
		      
		    	   
		       if(_i < (MaxDemoValues))
		       {
		    	   mHandler.postDelayed(this, 5000);
		    	   // set direction
		       
		       		sendMessageBluetooth("dl" + _listDirLeft[_i] +"\n");
		       		sendMessageBluetooth("dr" + _listDirRight[_i] +"\n");
					
		       		sendMessageBluetooth("l" + _listSpeedLeft[_i] +"\n");
		       		sendMessageBluetooth("r" + _listSpeedRight[_i] +"\n");
		    	   
		    	   // update seekBar
		    	   _seekBarR.setProgress(_listSpeedLeft[_i]);
		    	   _seekBarG.setProgress(_listSpeedRight[_i]);
	    	    
		    	   _i++;
		       }
		       else
		       {
		    	   _textInfo.setText("End Demo");
		    	   _i =0;
		       }
		    }
	};
*/
	
	 
	
	
	public void startScannerActivity(View view)
	{
		Log.v(TAG, "Start Scan");
		Intent  btScanIntent = new Intent(this, BtScannerActivity.class);
		//startActivity(btScanIntent);
		startActivityForResult(btScanIntent, BtCore.REQUEST_DISCOVERY);
	}
	
	// after select, connect to device
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode != BtCore.REQUEST_DISCOVERY) {
			return;
		}
		if (resultCode != RESULT_OK) {
			return;
		}
		BluetoothDevice device = data.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
		BtCore._serverAddressAfterScan =  device.getAddress();
	}
	

	@Override
	public void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		_textViewR = (TextView) findViewById(R.id.textViewR);
		_textViewR.setText("R:0");
		
		_textViewG = (TextView) findViewById(R.id.textViewG);
		_textViewG.setText("G:0");
        
		_textViewB = (TextView) findViewById(R.id.textViewB);
		_textViewB.setText("B:0");
        
		_seekBarR = (SeekBar)findViewById(R.id.seekbarR);
		_seekBarR.setOnSeekBarChangeListener(this);
		
		_seekBarG = (SeekBar)findViewById(R.id.seekbarG);
		_seekBarG.setOnSeekBarChangeListener(this);
		
		_seekBarB = (SeekBar)findViewById(R.id.seekbarB);
		_seekBarB.setOnSeekBarChangeListener(this);
		
		Toast msg = Toast.makeText(this, "Turn On the module Bluetooth", Toast.LENGTH_SHORT);
    	msg.setGravity(Gravity.TOP, msg.getXOffset() / 2, msg.getYOffset() / 2);
    	msg.show();
		
		_toggleOnOff = (ToggleButton) findViewById(R.id.toggleButtonOnOff);
		_toggleOnOff.setBackgroundColor(Color.GREEN);
		_toggleOnOff.setText("ON");
		_toggleOnOff.setOnClickListener(new View.OnClickListener() 
		{
		    public void onClick(View v) 
		    {
		    	int retCon = 0;	
		        // Perform action on clicks
		        if (_toggleOnOff.isChecked()) 
		        {  	
		    		int initRet = BtCore.initBluetooth();
		    		Log.v(TAG, "initBluetooth: "  +  initRet);
		    		
		   
		    		if (initRet == -1)
		    		{
		    			Toast.makeText(BtclientActivity.this, "Bluetooth is not available.", Toast.LENGTH_LONG).show();
		    			Log.e(TAG, "error -1");
		    			finish();
		    		}
		    		if (initRet == -2) 
		    		{
		    			Toast.makeText(BtclientActivity.this, "Please enable your BT and re-run this program.", Toast.LENGTH_LONG).show();
		    			Log.e(TAG, "error -2");
		    			finish();
		    		}
		    		
		    		int crtRet = BtCore.createSocketBluetooth();
		    		Log.v(TAG, "createSocketBluetooth: "  +  crtRet);

		        	retCon = BtCore.connectBluetooth();
		        	Log.v(TAG, "connectBluetooth:" + retCon);
		        	
		        	if (retCon != 0)
		        	{
			        	Toast toastStart = Toast.makeText(BtclientActivity.this, "no module bluetooth found!", Toast.LENGTH_LONG);
			        	toastStart.show();
			        	Log.v(TAG, "exit");
			        	
			        	_toggleOnOff.setChecked(false);

		        		return;		
		        	}
		        	Log.v(TAG, "On");
		        } 
		        else 
		        {
		        	if (retCon != 0)
		        	{
		        		return;
		        	}
					Log.v(TAG, "Off");
					
					BtCore.closeBluetooth();
		        }
		    }
		});
		
		
		_buttonScan = (Button) findViewById(R.id.buttonScan);
		_buttonScan.setOnClickListener(new View.OnClickListener()
		{
			public void onClick(View v)
			{
				startScannerActivity(v);
				Log.v(TAG, "onStartDiscoveryButtonClicked");
			}
		});
		
		
		
		// R buttons
		_buttonLeftR = (Button) findViewById(R.id.buttonRMinus);
		_buttonLeftR.setOnClickListener(new View.OnClickListener()
		{
			public void onClick(View v) 
			{    
				
				if((_RValue - _stepSpeed) < 0)
					return;
				_RValue -= _stepSpeed;
			
				_seekBarR.setProgress(_RValue);	
				_textViewR.setText("R:" + _RValue);
				
				BtCore.sendMessageBluetooth("R" + _RValue +"\n");
            }
        });
		_buttonRightR = (Button) findViewById(R.id.buttonRPlus);
		_buttonRightR.setOnClickListener(new View.OnClickListener() 
		{
			public void onClick(View v) 
			{
				if ((_RValue + _stepSpeed) > 255 )
					return;
				_RValue += _stepSpeed;
				
				_seekBarR.setProgress(_RValue);
				_textViewR.setText("R:" + _RValue);
				
				BtCore.sendMessageBluetooth("R" + _RValue +"\n");
            }
        });
		 
		// G buttons
		_buttonLeftG = (Button) findViewById(R.id.buttonGMinus);
		_buttonLeftG.setOnClickListener(new View.OnClickListener() 
		{
			
			
			public void onClick(View v) 
			{    
				if((_GValue - _stepSpeed) < 0)
					return;
				_GValue -= _stepSpeed;
			
				_seekBarG.setProgress(_GValue);	
				_textViewG.setText("G:" + _GValue);
				
				BtCore.sendMessageBluetooth("G" + _GValue +"\n");
            }
        });
		_buttonRightG = (Button) findViewById(R.id.buttonGPlus);
		_buttonRightG.setOnClickListener(new View.OnClickListener() 
		{
			public void onClick(View v) 
			{
				if ((_GValue + _stepSpeed) > 255 )
					return;
				_GValue += _stepSpeed;
				
				_seekBarG.setProgress(_GValue);
				_textViewG.setText("G:" + _GValue);
				
				BtCore.sendMessageBluetooth("G" + _GValue +"\n");
            }
        });
	
		// B Buttons
		_buttonLeftB = (Button) findViewById(R.id.buttonBMinus);
		_buttonLeftB.setOnClickListener(new View.OnClickListener() 
		{
			public void onClick(View v) 
			{    
				if((_BValue - _stepSpeed) < 0)
					return;
				_BValue -= _stepSpeed;
			
				_seekBarB.setProgress(_BValue);	
				_textViewB.setText("B:" + _BValue);
				
				BtCore.sendMessageBluetooth("B" + _BValue +"\n");
            }
        });
		_buttonRightB = (Button) findViewById(R.id.buttonBPlus);
		_buttonRightB.setOnClickListener(new View.OnClickListener() 
		{
			public void onClick(View v) 
			{
				if ((_BValue + _stepSpeed) > 255 )
					return;
				_BValue += _stepSpeed;
				
				_seekBarB.setProgress(_BValue);
				_textViewB.setText("B:" + _BValue);
				
				BtCore.sendMessageBluetooth("B" + _BValue +"\n");
            }
        });
	

	}
	
	
	// progressBar 
    public void onProgressChanged(SeekBar seekBar, int progress, boolean fromTouch) 
    {
    	int id = seekBar.getId();
    		
    	if (id == R.id.seekbarR)
    	{
    		_RValue = progress;
    		_textViewR.setText("R:" + progress);	
    		BtCore.sendMessageBluetooth("R" + progress +"\n");
    	}
    	
    	if (id == R.id.seekbarG)
    	{
    		_GValue = progress;
    		_textViewG.setText("G:" + progress);	
    		BtCore.sendMessageBluetooth("G" + progress +"\n");
    	}
    	
    	if (id == R.id.seekbarB)
    	{
    		_BValue = progress;
    		_textViewB.setText("B:" + progress);	
    		BtCore.sendMessageBluetooth("B" + progress +"\n");
    	}
 
    }
    
   
    public void onStartTrackingTouch(SeekBar seekBar) 
    {  
    }

    public void onStopTrackingTouch(SeekBar seekBar) 
    {
    }

	

	@Override
	public void onStart() 
	{
		super.onStart();
		if (Debug)
		{
			Log.e(TAG, "START");
		}
	}

	@Override
	public void onResume() 
	{
		super.onResume();
		if (Debug)
		{
			Log.e(TAG, "RESUME");
		} 
	}

	@Override
	public void onPause() 
	{
		super.onPause();
		if (Debug)
		{
			Log.e(TAG, "- ON PAUSE -");
		}
		//closeBluetooth();
	}

	@Override
	public void onStop() 
	{
		super.onStop();
		if (Debug)
		{
			Log.e(TAG, "-- ON STOP --");
		}
	}

	@Override
	public void onDestroy() 
	{
		super.onDestroy();
		if (Debug)
		{
			Log.e(TAG, "--- ON DESTROY ---");
		}
	}
}

